codeforces 427E

题意:给定一位空间里n个点的坐标,每个坐标有一个罪犯,现在要建一个警局,并且这个警局只有一辆车,车一次最多载m个人,问应建在哪是的抓回所有罪犯的路程和最小。

思路:

很明显建在罪犯的点上一定可以找到最优解。

那么直接枚举建在哪一个点。。

那么抓罪犯肯定从两边抓最优。所以预处理两个数组即可。。

code:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 typedef long long ll;
 4 int a[1001010], n, m;
 5 ll sl[1001010], sr[1010000];
 6
 7 void solve(){
 8     for (int i = 1; i <= n; ++i){
 9           scanf("%d", &a[i]);
10           if ((i-1) % m == 0) sl[i] = sl[max(i-m, 0)] + a[i];
11     }
12     for (int i = n; i >= 1; --i)
13          if ((n-i) % m == 0)  sr[i] = sr[min(n+1, i + m)] + a[i];
14     ll ans = 1LL<<50;
15     int l, r, lr, rr;
16     int cnt = (n - 1) / m + 1;
17     rr = n - (cnt-1) * m;
18 //    cout << rr << endl;
19     ans = sr[rr] - (ll)cnt * a[1];
20 //    cout << ans << endl;
21     lr = 1 + (cnt-1) * m;
22     ans = min((ll)cnt * a[n] - sl[lr], ans);
23 //    cout << ans << endl;
24     ll tmp, cnt1, cnt2;
25     for (int i = 2; i <= n; ++i){
26         l = i - 1, r = i;
27         cnt1 = (l - 1) / m + 1, cnt2 = (n - r) / m + 1;
28         lr = 1 + (cnt1 - 1) * m, rr = n - (cnt2 - 1) * m;
29 //        if (i == 2){
30 //              printf("lr = %d rr = %d\n", lr, rr);
31 //        }
32         tmp = (ll)a[r] * cnt1 - sl[lr] + sr[rr] - (ll)a[r] * cnt2;
33 //        printf("%d %lld\n", i, tmp);
34         ans = min(ans, tmp);
35     }
36     cout << ans * 2 << endl;
37 }
38 int main(){
39 //    freopen("a.in", "r", stdin);
40     while (scanf("%d%d", &n, &m) != EOF){
41          solve();
42     }
43 }

时间: 2024-10-10 05:56:43

codeforces 427E的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ